

/*
Author        : ZULQANI FAUZI
Created Date  : 05 / 07 / 2018
Updated Date  : 16 / 07 / 2018
*/

import {Component} from '@angular/core';
import {IonicPage, NavController, NavParams, AlertController, ToastController} from 'ionic-angular';
import {AuthService} from "../../providers/auth-service";
import {Common} from "../../providers/common";
import {CartPage} from '../cart/cart';
import {AddproductPage} from '../addproduct/addproduct';

@IonicPage()
@Component({
    selector: 'page-product',
    templateUrl: 'product.html',
})
export class ProductPage {
    public userDetails: any;
    public resposeData: any;
    public recartData: any;
    public cartData: any;
    public dataProduct: any;
    public dataCategory: any;
    public categoryData: any;
    public noRecords: boolean;
    public dataPrint: any;
    public adaPromo: boolean = true;
    selectedPrinter: any = [];

    public total_item: 0;
    public total: 0;
    userPostData = {
        nama_depan: "",
        nama_belakang: "",
        id_member: ""
    };

    userCart = {
        cart_id: "",
        id_pelanggan: "",
        nama_pelanggan: "",
        username: "",
        ItemID: "",
        quantity: "",
        price: "",
        token: "",
        cart_item_id: "",
        catatan: "",
        diskon: "",
        jumlah_diskon: 0,
        promo: "",
        id_promo: "",
        pajak: true,
        ppn: 0
    }

    stepper2: number;
    private valQty = 0;

    constructor(public navCtrl: NavController,
        public navParams: NavParams,
        public alertCtrl: AlertController,
        public authService: AuthService,
        public common: Common,
        private toastCtrl: ToastController) {
        const data = JSON.parse(localStorage.getItem("userData"));
        this.userDetails = data.userData;
        this.userCart.username = this.userDetails.username;
        this.userCart.token = this.userDetails.token;
        this.userCart.jumlah_diskon = 0;
        this.loadProduk();
//        this.getCart();
    }

    ionViewDidLoad() {}

    quantity($value) {
        this.valQty = $value;
    }

    ListCart() {
        this.navCtrl.push(CartPage, {'cart_id': this.userCart.cart_id, 'username': this.userCart.username});
    }
    addProduct(){
        this.navCtrl.push(AddproductPage);
    }

//    insertCart($data) {
//        this.common.presentLoading();
//        this.userCart.price = $data.UnitPrice;
//        this.userCart.quantity = "1";
//        this.userCart.ItemID = $data.ItemID;
//        if (this.userCart.id_pelanggan === '') {
//            this.userCart.id_pelanggan = '0001';
//            this.userCart.nama_pelanggan = 'UMUM';
//        }
//        if (this.userCart.ItemID) {
//            this.authService.postData(this.userCart, "insertCart").then(
//                result => {
//                    this.resposeData = result;
//                    if (this.resposeData.cartData) {
//                        this.cartData = this.resposeData.cartData;
//                        this.total_item = this.cartData.length;
//                        this.common.closeLoading();
//                        setTimeout(() => {
//                        }, 150);
//                    }
//                },
//                err => {
//                    this.common.closeLoading();
//                    this.presentToast("Gagal terhubung ke server.");
//                }
//            );
//        } else {
//            this.common.closeLoading();
//            this.presentToast("Gagal mengambil produk.");
//        }
//    }
//
//    getCart() {
//        this.authService.postData(this.userCart, "getCart").then(
//            result => {
//                this.recartData = result;
//                if (this.recartData.cartData) {
//                    this.cartData = this.recartData.cartData;
//                    this.userCart.cart_id = this.cartData[0].cart_id;
//                    this.userCart.id_pelanggan = this.cartData[0].id_pelanggan;
//                    this.userCart.nama_pelanggan = this.cartData[0].nama_depan + " " + this.cartData[0].nama_belakang;
//                    this.userCart.promo = this.cartData[0].promo;
//                    this.total_item = this.cartData.length;
//                }
//            },
//            err => {
//                this.presentToast("Gagal terhubung ke server.");
//            }
//        );
//    }
//
//    updateCart($value) {
//        this.userCart.cart_item_id = $value.cart_item_id;
//        this.userCart.quantity = $value.quantity;
//        this.userCart.price = $value.price;
//        this.userCart.ItemID = $value.product_id;
//        this.authService.postData(this.userCart, "updateCart").then(
//            result => {
//                this.recartData = result;
//                if (this.recartData.cartData) {
//                    this.cartData = this.recartData.cartData;
//                    this.total_item = this.cartData.length;
//                }
//            },
//            err => {
//                this.presentToast("Gagal terhubung ke server.");
//            }
//        );
//    }

    loadProduk() {
        this.authService.postData(this.userPostData, "allproduct").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.productData) {
                    this.common.closeLoading();
                    this.dataProduct = this.resposeData.productData;
                    const dataLength = this.resposeData.productData.length;
                    if (dataLength == 0) {
                        this.noRecords = true;
                    }
                } else {
                    this.noRecords = true;
                }
            },
            err => {
                this.noRecords = true;
            }
        );
    }
    getItems(searchbar) {
        this.loadProduk();
        console.log(this.dataProduct.ItemName);
        var q = searchbar.value;

        if (q.trim() == '') {
            return;
        }

        this.dataProduct = this.dataProduct.filter((v) => {

            if (v.name.toLowerCase().indexOf(q.toLowerCase()) > -1) {
                return true;
            }

            return false;
        })
    }

    onCancelSearchbar(searchbar) {
        this.loadProduk();
    }

    onClearSearchbar(searchbar) {
        this.loadProduk();
    }
    

    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    }

}
